#include "stdafx.h"
#include "powerstate.h"

CPowerState::CPowerState()
{
	AdjustToken( true );
}

CPowerState::~CPowerState()
{
	AdjustToken( false );
}

bool CPowerState::Standby()
{
	return (::SetSystemPowerState( TRUE, FALSE ))
		? true : false;
}

bool CPowerState::Hibernate()
{
	return (::SetSystemPowerState( FALSE, FALSE ))
		? true : false;
}

bool CPowerState::AdjustToken(bool bEnable)
{
	bool bResult = false;
	HANDLE hToken = NULL;

	try
	{
		BOOL bRes = ::OpenProcessToken(
			::GetCurrentProcess( ),
			TOKEN_ADJUST_PRIVILEGES,
			&hToken );

		if (!bRes)
			throw ::GetLastError( );

		TOKEN_PRIVILEGES tp;
		LUID luid;

		bRes = ::LookupPrivilegeValue(
			NULL,
			SE_SHUTDOWN_NAME,
			&luid );

		if (!bRes)
			throw ::GetLastError( );

		tp.PrivilegeCount = 1;
		tp.Privileges[ 0 ].Luid = luid;
		tp.Privileges[ 0 ].Attributes =
			(bEnable) ? SE_PRIVILEGE_ENABLED : 0;

		bRes = ::AdjustTokenPrivileges(
			hToken,
			FALSE,
			&tp,
			sizeof(TOKEN_PRIVILEGES),
			NULL,
			NULL );
		DWORD dwError = ::GetLastError( );

		if (!bRes || (dwError != ERROR_SUCCESS))
			throw dwError;

		bResult = true;
	}
	catch (DWORD dwError)
	{
		TCHAR szError[ 512 ];
		::wsprintf( szError, TEXT("The operation failed with error 0x%.8X."), dwError );
		::MessageBox(
			NULL,
			szError,
			TEXT("Error"),
			MB_OK | MB_ICONSTOP );
	}

	if (hToken)
		::CloseHandle( hToken );

	return bResult;
}
